Bug 1824016 - Review Request: neatvnc - a liberally licensed VNC server library
Summary: Review Request: neatvnc - a liberally licensed VNC server library
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Aleksei Bavshin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-04-15 04:36 UTC by Bob Hepple
Modified: 2020-04-27 04:47 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-04-27 02:43:32 UTC
Type: ---
alebastr89: fedora-review+


Attachments (Terms of Use)

Description Bob Hepple 2020-04-15 04:36:31 UTC
Spec URL: https://download.copr.fedorainfracloud.org/results/wef/wayvnc/fedora-31-x86_64/01338222-neatvnc/neatvnc.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/wef/wayvnc/fedora-31-x86_64/01338222-neatvnc/neatvnc-0.1.0-1.fc31.src.rpm
Description: 

This is a liberally licensed VNC server library that's intended to be
fast and neat. Note: This is a beta release, so the interface is not
yet stable.

Fedora Account System Username: wef

Comment 1 Aleksei Bavshin 2020-04-15 05:28:04 UTC
Some things to address before formal review:

> License:  ISC

ISC and MIT and Unlicense (with comment about bundled miniz)
Also, `Provides: bundled(miniz) = 2.1.0` with a comment that it's already removed in upstream master.

> BuildRequires: cmake

Not necessary, all dependencies are shipping pkgconfig files. CMake is only required when you know that there's dependency that does not have pkgconfig file but provides cmake modules.

> %files
> %{_libdir}/lib%{name}.so.*

Please, specify at least one element of SONAME to avoid unnoticed incompatible SONAME changes[1]. I.e. %{_libdir}/lib%{name}.so.0* 

> %{_includedir}/*

I'd prefer this to be more specific, but that's just nitpicking.

> cpu = host_machine.cpu_family()
> 
> if cpu == 'x86_64'
> 	c_args += '-mavx'
> elif cpu == 'arm'
> 	c_args += '-mfpu=neon'
> endif

It's better to remove that from meson.build with downstream patch. Upstream issue[2] mentions that at least x86_64 works fine without -mavx, although it does not specify if there's any noticeable performance loss.
IIRC, Fedora baseline for x86_64 is K8 (no avx support) and for ARM - hardware without neon instruction set support. I could be wrong about ARM, but it's still better to keep optimization limited to distribution-wide optflags.

[1] https://docs.fedoraproject.org/en-US/packaging-guidelines/#_listing_shared_library_files
[2] https://github.com/any1/neatvnc/issues/21

Comment 3 Aleksei Bavshin 2020-04-16 06:22:31 UTC
> License:  ISC and MIT and Unlicensed and BSD
> # miniz is unlicensed: http://unlicense.org

Unlicensed -> Unlicense.
Would be even better to write a detailed distribution of licenses, i.e. something like this:

# main source is ISC
# include/sys/queue.h is BSD
# bundled miniz is MIT and Unlicense
License:  ISC and BSD and MIT and Unlicense

Otherwise I don't see any issues. Package builds in mock, wayvnc works, requires/provides are good and rpmlint's only significant complaint is about invalid license (Unlicensed). Full output of fedora-review is long, boring and has nothing of note. Thanks for all the work on the package!

I'd set both this and wayvnc as approved, but apparently a faulty script did not grant me reviewer permissions in bugzilla and I cannot take the bug or set fedora-review+. I already pinged infra team and they'll fix that sooner or later. Meanwhile... maybe someone could step in and finish the review.

Comment 5 Aleksei Bavshin 2020-04-16 22:50:23 UTC
Package approved. Thanks for all the work on this package!

I'm approving bundling of existing Fedora package miniz on the rationale that upstream already got rid of that and switched to system zlib, but there's no upstream patch that could be cleanly applied to the released version. Too much effort to deal with something that would be fixed in the next upstream release.




Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "ISC License", "Unknown or generated", "Expat License", "BSD
     3-clause "New" or "Revised" License". 25 files have unknown license.
     Detailed output of licensecheck in
     /home/alebastr/rpmbuild/GIT/neatvnc/1824016-neatvnc/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
[-]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: neatvnc-0.1.0-3.fc33.x86_64.rpm
          neatvnc-devel-0.1.0-3.fc33.x86_64.rpm
          neatvnc-debuginfo-0.1.0-3.fc33.x86_64.rpm
          neatvnc-debugsource-0.1.0-3.fc33.x86_64.rpm
          neatvnc-0.1.0-3.fc33.src.rpm
neatvnc-devel.x86_64: W: no-documentation
5 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (debuginfo)
-------------------
Checking: neatvnc-debuginfo-0.1.0-3.fc33.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
neatvnc-debuginfo.x86_64: W: invalid-url URL: https://github.com/any1/neatvnc <urlopen error [Errno -2] Name or service not known>
neatvnc-devel.x86_64: W: invalid-url URL: https://github.com/any1/neatvnc <urlopen error [Errno -2] Name or service not known>
neatvnc-devel.x86_64: W: no-documentation
neatvnc.x86_64: W: invalid-url URL: https://github.com/any1/neatvnc <urlopen error [Errno -2] Name or service not known>
neatvnc-debugsource.x86_64: W: invalid-url URL: https://github.com/any1/neatvnc <urlopen error [Errno -2] Name or service not known>
4 packages and 0 specfiles checked; 0 errors, 5 warnings.



Source checksums
----------------
https://github.com/any1/neatvnc/archive/v0.1.0/neatvnc-0.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : b2a99cd85ad5414f7d8a5203107d1ce6b65d57bec8d28d1efc7362de8b4c7923
  CHECKSUM(SHA256) upstream package : b2a99cd85ad5414f7d8a5203107d1ce6b65d57bec8d28d1efc7362de8b4c7923


Requires
--------
neatvnc (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libgnutls.so.30()(64bit)
    libgnutls.so.30(GNUTLS_3_4)(64bit)
    libpixman-1.so.0()(64bit)
    libpthread.so.0()(64bit)
    libuv.so.1()(64bit)
    rtld(GNU_HASH)

neatvnc-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libneatvnc.so.0()(64bit)
    neatvnc(x86-64)

neatvnc-debuginfo (rpmlib, GLIBC filtered):

neatvnc-debugsource (rpmlib, GLIBC filtered):



Provides
--------
neatvnc:
    bundled(miniz)
    libneatvnc.so.0()(64bit)
    neatvnc
    neatvnc(x86-64)

neatvnc-devel:
    neatvnc-devel
    neatvnc-devel(x86-64)
    pkgconfig(neatvnc)

neatvnc-debuginfo:
    debuginfo(build-id)
    neatvnc-debuginfo
    neatvnc-debuginfo(x86-64)

neatvnc-debugsource:
    neatvnc-debugsource
    neatvnc-debugsource(x86-64)



Generated by fedora-review 0.7.5 (5fa5b7e) last change: 2020-02-16
Command line :/usr/bin/fedora-review -b 1824016
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, C/C++, Shell-api
Disabled plugins: PHP, R, SugarActivity, Haskell, Ocaml, Python, fonts, Perl, Java
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 6 Gwyn Ciesla 2020-04-17 13:16:21 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/neatvnc

Comment 7 Fedora Update System 2020-04-17 23:15:01 UTC
FEDORA-2020-23d9642273 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-23d9642273

Comment 8 Fedora Update System 2020-04-17 23:21:50 UTC
FEDORA-2020-7fb0ebcb35 has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2020-7fb0ebcb35

Comment 9 Fedora Update System 2020-04-19 04:26:49 UTC
FEDORA-2020-7fb0ebcb35 has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-7fb0ebcb35 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-7fb0ebcb35

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 10 Fedora Update System 2020-04-19 21:48:36 UTC
FEDORA-2020-23d9642273 has been pushed to the Fedora 31 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-23d9642273 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-23d9642273

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 11 Fedora Update System 2020-04-27 02:43:32 UTC
FEDORA-2020-7fb0ebcb35 has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 12 Fedora Update System 2020-04-27 04:47:10 UTC
FEDORA-2020-23d9642273 has been pushed to the Fedora 31 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.